local light = {x=1,y=1}

local rayLen = 600

local rayAmount = 100

local rays = {}
for i=1,rayAmount do
  table.insert(rays,{angle=(math.pi*2/rayAmount)*i,len=rayLen})
end

local player = {x=0,y=0,size=10,speed=2}

math.randomseed(os.time())

local boxes = {}
for i=1,10 do
  table.insert(boxes,{x=math.random(0,love.graphics.getWidth()),y=math.random(0,love.graphics.getHeight()),w=math.random(100,200),h=math.random(100,200)})
end

function controlRays()
  for _,ray in ipairs(rays) do
    ray.len = 0
    local keepdoing = true
    for i=1,rayLen do
      if keepdoing then
        ray.len = i-1
        for _,box in ipairs(boxes) do
          if light.x+(math.cos(ray.angle)*ray.len) >= box.x and light.x+(math.cos(ray.angle)*ray.len) <= box.x+box.w and
          light.y+(math.sin(ray.angle)*ray.len) >= box.y and light.y+(math.sin(ray.angle)*ray.len) <= box.y+box.h then
            keepdoing = false
          end
        end
        if light.x+(math.cos(ray.angle)*ray.len) >= love.graphics.getWidth() or light.x+(math.cos(ray.angle)*ray.len) <= 0 
        or light.y+(math.sin(ray.angle)*ray.len) >= love.graphics.getHeight() or light.y+(math.sin(ray.angle)*ray.len) <= 0 then
          keepdoing = false
        end
      end
    end
  end
end

function love.update(dt)
  local t = dt * 50
  if love.keyboard.isDown('up') or love.keyboard.isDown('down') then
    if love.keyboard.isDown('up') then rayAmount = rayAmount + 1 end
    if love.keyboard.isDown('down') then rayAmount = rayAmount - 1 end
    rays = {}
    for i=1,rayAmount do
      table.insert(rays,{angle=(math.pi*2/rayAmount)*i,len=rayLen})
    end
  end
  light.x,light.y = love.mouse.getPosition()
  controlRays()
  love.window.setTitle("fps " .. love.timer.getFPS())
end

function love.keypressed(key)
end

function love.draw()
  love.graphics.setColor(0,255,255,50)
  love.graphics.circle("fill",light.x,light.y,rayLen)
  love.graphics.setColor(255,255,255)
  for _,ray in ipairs(rays) do
    love.graphics.arc("fill",light.x,light.y,ray.len,ray.angle,ray.angle+math.pi*2/rayAmount)
  end
  love.graphics.setColor(255,0,0)
  for _,box in ipairs(boxes) do
    love.graphics.rectangle("fill",box.x,box.y,box.w,box.h)
  end
  love.graphics.setColor(220,220,220)
  love.graphics.circle("fill",light.x,light.y,10)
  love.graphics.setColor(0,255,0)
  love.graphics.print(rayAmount .. " rays")
end